"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _propTypesExact = _interopRequireDefault(require("prop-types-exact"));

var _link = _interopRequireDefault(require("next/link"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _router = _interopRequireDefault(require("next/router"));

var _url = require("url");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// Copied from 'prop-types-exact'
var zeroWidthSpace = "\u200B";
var specialProperty = "prop-types-exact: ".concat(zeroWidthSpace);

var DataPrefetchLink =
/*#__PURE__*/
function (_Link) {
  _inherits(DataPrefetchLink, _Link);

  function DataPrefetchLink() {
    _classCallCheck(this, DataPrefetchLink);

    return _possibleConstructorReturn(this, _getPrototypeOf(DataPrefetchLink).apply(this, arguments));
  }

  _createClass(DataPrefetchLink, [{
    key: "prefetch",
    value: function prefetch() {
      var _this = this;

      if (typeof window === 'undefined' || !this.props.prefetch) {
        return;
      }

      var pathname = window.location.pathname;
      var hrefString = this.props.href !== 'string' ? (0, _url.format)(this.props.href) : this.props.href;
      var href = (0, _url.resolve)(pathname, hrefString);

      var _parse = (0, _url.parse)(href, true),
          query = _parse.query;

      return _router.default.prefetch(href).then(function (Component) {
        if (_this.props.withData && Component && Component.getInitialProps && typeof Component.getInitialProps === 'function') {
          var ctx = {
            pathname: href,
            query: query,
            isVirtualCall: true
          };
          return Component.getInitialProps(ctx).then(function () {
            return Component;
          });
        }
      });
    }
  }], [{
    key: "getLinkPropTypesNoExact",
    value: function getLinkPropTypesNoExact() {
      var linkPropTypes = _objectSpread({}, _link.default.propTypes);

      delete linkPropTypes[specialProperty];
      return linkPropTypes;
    }
  }]);

  return DataPrefetchLink;
}(_link.default);

exports.default = DataPrefetchLink;

_defineProperty(DataPrefetchLink, "propTypes", (0, _propTypesExact.default)(_objectSpread({}, DataPrefetchLink.getLinkPropTypesNoExact(), {
  withData: _propTypes.default.bool
})));